(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', './kotlin-kotlin-stdlib.js', './kotlin-codepoints-parent-kotlin-codepoints.js'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./kotlin-codepoints-parent-kotlin-codepoints.js'));
  else {
    if (typeof this['kotlin-kotlin-stdlib'] === 'undefined') {
      throw new Error("Error loading module 'com.dzikoysk:khangul'. Its dependency 'kotlin-kotlin-stdlib' was not found. Please, check whether 'kotlin-kotlin-stdlib' is loaded prior to 'com.dzikoysk:khangul'.");
    }
    if (typeof this['kotlin-codepoints-parent-kotlin-codepoints'] === 'undefined') {
      throw new Error("Error loading module 'com.dzikoysk:khangul'. Its dependency 'kotlin-codepoints-parent-kotlin-codepoints' was not found. Please, check whether 'kotlin-codepoints-parent-kotlin-codepoints' is loaded prior to 'com.dzikoysk:khangul'.");
    }
    root['com.dzikoysk:khangul'] = factory(typeof this['com.dzikoysk:khangul'] === 'undefined' ? {} : this['com.dzikoysk:khangul'], this['kotlin-kotlin-stdlib'], this['kotlin-codepoints-parent-kotlin-codepoints']);
  }
}(globalThis, function (_, kotlin_kotlin, kotlin_kotlin_codepoints_parent_kotlin_codepoints) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var THROW_IAE = kotlin_kotlin.$_$.d1;
  var Unit_instance = kotlin_kotlin.$_$.i;
  var Enum = kotlin_kotlin.$_$.c1;
  var protoOf = kotlin_kotlin.$_$.v;
  var defineProp = kotlin_kotlin.$_$.p;
  var initMetadataForClass = kotlin_kotlin.$_$.q;
  var VOID = kotlin_kotlin.$_$.b;
  var charSequenceLength = kotlin_kotlin.$_$.o;
  var charSequenceGet = kotlin_kotlin.$_$.n;
  var Char__toInt_impl_vasixd = kotlin_kotlin.$_$.g;
  var dropLast = kotlin_kotlin.$_$.y;
  var toString = kotlin_kotlin.$_$.h;
  var noWhenBranchMatchedException = kotlin_kotlin.$_$.e1;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.f;
  var Char = kotlin_kotlin.$_$.b1;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.c;
  var copyToArray = kotlin_kotlin.$_$.j;
  var split = kotlin_kotlin.$_$.a1;
  var charArrayOf = kotlin_kotlin.$_$.m;
  var toString_0 = kotlin_kotlin.$_$.w;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.e;
  var indexOf = kotlin_kotlin.$_$.k;
  var numberRangeToNumber = kotlin_kotlin.$_$.s;
  var numberToInt = kotlin_kotlin.$_$.u;
  var primitiveArrayConcat = kotlin_kotlin.$_$.a;
  var initMetadataForObject = kotlin_kotlin.$_$.r;
  var until = kotlin_kotlin.$_$.x;
  var slice = kotlin_kotlin.$_$.z;
  var StringBuilder_init_$Create$ = kotlin_kotlin.$_$.d;
  var appendCodePoint = kotlin_kotlin_codepoints_parent_kotlin_codepoints.$_$.a;
  var toIntArray = kotlin_kotlin.$_$.l;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(RemovePolicy, 'RemovePolicy', VOID, Enum);
  initMetadataForClass(HangulContext, 'HangulContext', HangulContext);
  initMetadataForClass(Symbol, 'Symbol');
  initMetadataForObject(HangulProcessor, 'HangulProcessor');
  //endregion
  var RemovePolicy_DEFAULT_instance;
  var RemovePolicy_REFORMAT_ON_DELETE_instance;
  function values() {
    return [RemovePolicy_DEFAULT_getInstance(), RemovePolicy_REFORMAT_ON_DELETE_getInstance()];
  }
  function valueOf(value) {
    switch (value) {
      case 'DEFAULT':
        return RemovePolicy_DEFAULT_getInstance();
      case 'REFORMAT_ON_DELETE':
        return RemovePolicy_REFORMAT_ON_DELETE_getInstance();
      default:
        RemovePolicy_initEntries();
        THROW_IAE('No enum constant value.');
        break;
    }
  }
  var RemovePolicy_entriesInitialized;
  function RemovePolicy_initEntries() {
    if (RemovePolicy_entriesInitialized)
      return Unit_instance;
    RemovePolicy_entriesInitialized = true;
    RemovePolicy_DEFAULT_instance = new RemovePolicy('DEFAULT', 0);
    RemovePolicy_REFORMAT_ON_DELETE_instance = new RemovePolicy('REFORMAT_ON_DELETE', 1);
  }
  function RemovePolicy(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  function insertAtCaret($this, value) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var tmp = $this;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp_0 = $this.d4_1.substring(0, selectionStart) + value;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp.d4_1 = tmp_0 + $this.d4_1.substring(selectionEnd);
    $this.e4_1 = $this.d4_1.length;
  }
  function deleteAtCaret($this, count, to) {
    var selectionStart = getSelectionStart($this);
    var selectionEnd = getSelectionEnd($this);
    var contentLength = $this.d4_1.length;
    // Inline function 'kotlin.math.min' call
    var deleteFrom = Math.min(count, selectionStart);
    var deleteTo = (selectionEnd + to | 0) > contentLength ? contentLength - selectionEnd | 0 : to;
    // Inline function 'kotlin.text.substring' call
    var this_0 = $this.d4_1;
    var startIndex = selectionStart - deleteFrom | 0;
    var endIndex = selectionEnd + deleteTo | 0;
    // Inline function 'kotlin.js.asDynamic' call
    var deleted = this_0.substring(startIndex, endIndex);
    var tmp = $this;
    // Inline function 'kotlin.text.substring' call
    var this_1 = $this.d4_1;
    var endIndex_0 = selectionStart - deleteFrom | 0;
    // Inline function 'kotlin.js.asDynamic' call
    var tmp_0 = this_1.substring(0, endIndex_0);
    // Inline function 'kotlin.text.substring' call
    var this_2 = $this.d4_1;
    var startIndex_0 = selectionEnd + deleteTo | 0;
    // Inline function 'kotlin.js.asDynamic' call
    tmp.d4_1 = tmp_0 + this_2.substring(startIndex_0);
    setCaretPosition($this, selectionStart - deleteFrom | 0);
    return deleted;
  }
  function deleteAtCaret$default($this, count, to, $super) {
    to = to === VOID ? 0 : to;
    return deleteAtCaret($this, count, to);
  }
  function setCaretPosition($this, position) {
    $this.e4_1 = position;
  }
  function getSelectionEnd($this) {
    return $this.e4_1;
  }
  function getSelectionStart($this) {
    return $this.e4_1;
  }
  function HangulContext(initialPhrase, removePolicy) {
    initialPhrase = initialPhrase === VOID ? '' : initialPhrase;
    removePolicy = removePolicy === VOID ? RemovePolicy_DEFAULT_getInstance() : removePolicy;
    this.c4_1 = removePolicy;
    this.d4_1 = initialPhrase;
    this.e4_1 = initialPhrase.length;
  }
  protoOf(HangulContext).clear = function () {
    this.d4_1 = '';
    this.e4_1 = 0;
  };
  protoOf(HangulContext).appendLetter = function (letter) {
    insertAtCaret(this, letter);
    var deleted = deleteAtCaret$default(this, 2);
    insertAtCaret(this, this.composeHangul(deleted));
  };
  protoOf(HangulContext).appendLetters = function (letters) {
    // Inline function 'kotlin.collections.forEach' call
    var inductionVariable = 0;
    var last = letters.length;
    while (inductionVariable < last) {
      var element = letters[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'HangulContext.appendLetters.<anonymous>' call
      this.appendLetter(element);
    }
  };
  protoOf(HangulContext).removeLastLetter = function () {
    var deleted = deleteAtCaret$default(this, 1);
    var tmp;
    // Inline function 'kotlin.text.isNotEmpty' call
    var this_0 = deleted;
    if (charSequenceLength(this_0) > 0) {
      // Inline function 'kotlin.code' call
      var this_1 = charSequenceGet(deleted, 0);
      var containsArg = Char__toInt_impl_vasixd(this_1);
      tmp = 56320 <= containsArg ? containsArg <= 57343 : false;
    } else {
      tmp = false;
    }
    if (tmp) {
      deleted = deleteAtCaret$default(this, 1) + deleted;
    }
    var decomposed = this.decomposeHangul(deleted);
    if (decomposed.length > 1) {
      switch (this.c4_1.e1_1) {
        case 0:
          insertAtCaret(this, this.composeHangul(dropLast(decomposed, 1)));
          break;
        case 1:
          // Inline function 'kotlin.text.forEach' call

          var indexedObject = dropLast(decomposed, 1);
          var inductionVariable = 0;
          while (inductionVariable < charSequenceLength(indexedObject)) {
            var element = charSequenceGet(indexedObject, inductionVariable);
            inductionVariable = inductionVariable + 1 | 0;
            // Inline function 'HangulContext.removeLastLetter.<anonymous>' call
            this.appendLetter(toString(element));
          }

          break;
        default:
          noWhenBranchMatchedException();
          break;
      }
    }
  };
  protoOf(HangulContext).composeHangul = function (value) {
    return HangulProcessor_getInstance().v4(value);
  };
  protoOf(HangulContext).w4 = function (value) {
    var tmp = HangulProcessor_getInstance();
    return tmp.x4(value == null ? this.d4_1 : value);
  };
  protoOf(HangulContext).decomposeHangul = function (value, $super) {
    value = value === VOID ? null : value;
    return this.w4(value);
  };
  protoOf(HangulContext).getValue = function () {
    return this.d4_1;
  };
  function RemovePolicy_DEFAULT_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_DEFAULT_instance;
  }
  function RemovePolicy_REFORMAT_ON_DELETE_getInstance() {
    RemovePolicy_initEntries();
    return RemovePolicy_REFORMAT_ON_DELETE_instance;
  }
  function Symbol(value, compoundOf) {
    compoundOf = compoundOf === VOID ? null : compoundOf;
    this.y4_1 = value;
    this.z4_1 = compoundOf;
  }
  function HangulProcessor() {
    HangulProcessor_instance = this;
    var tmp = this;
    // Inline function 'kotlin.arrayOf' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp.f4_1 = [new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12600)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12611)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12617)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    var tmp_0 = this;
    // Inline function 'kotlin.collections.toTypedArray' call
    // Inline function 'kotlin.collections.map' call
    var this_0 = this.f4_1;
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(this_0.length);
    var inductionVariable = 0;
    var last = this_0.length;
    while (inductionVariable < last) {
      var item = this_0[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'HangulProcessor.initialCodes.<anonymous>' call
      // Inline function 'kotlin.code' call
      var this_1 = item.q_1;
      var tmp$ret$4 = Char__toInt_impl_vasixd(this_1);
      destination.x1(tmp$ret$4);
    }
    tmp_0.g4_1 = copyToArray(destination);
    var tmp_1 = this;
    // Inline function 'kotlin.arrayOf' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp_1.h4_1 = [new Char(_Char___init__impl__6a9atx(0)), new Char(_Char___init__impl__6a9atx(12593)), new Char(_Char___init__impl__6a9atx(12594)), new Char(_Char___init__impl__6a9atx(12595)), new Char(_Char___init__impl__6a9atx(12596)), new Char(_Char___init__impl__6a9atx(12597)), new Char(_Char___init__impl__6a9atx(12598)), new Char(_Char___init__impl__6a9atx(12599)), new Char(_Char___init__impl__6a9atx(12601)), new Char(_Char___init__impl__6a9atx(12602)), new Char(_Char___init__impl__6a9atx(12603)), new Char(_Char___init__impl__6a9atx(12604)), new Char(_Char___init__impl__6a9atx(12605)), new Char(_Char___init__impl__6a9atx(12606)), new Char(_Char___init__impl__6a9atx(12607)), new Char(_Char___init__impl__6a9atx(12608)), new Char(_Char___init__impl__6a9atx(12609)), new Char(_Char___init__impl__6a9atx(12610)), new Char(_Char___init__impl__6a9atx(12612)), new Char(_Char___init__impl__6a9atx(12613)), new Char(_Char___init__impl__6a9atx(12614)), new Char(_Char___init__impl__6a9atx(12615)), new Char(_Char___init__impl__6a9atx(12616)), new Char(_Char___init__impl__6a9atx(12618)), new Char(_Char___init__impl__6a9atx(12619)), new Char(_Char___init__impl__6a9atx(12620)), new Char(_Char___init__impl__6a9atx(12621)), new Char(_Char___init__impl__6a9atx(12622))];
    this.i4_1 = split(',\u3131,\u3132,\u3131\u3145,\u3134,\u3134\u3148,\u3134\u314E,\u3137,\u3139,\u3139\u3131,\u3139\u3141,\u3139\u3142,\u3139\u3145,\u3139\u314C,\u3139\u314D,\u3139\u314E,\u3141,\u3142,\u3142\u3145,\u3145,\u3146,\u3147,\u3148,\u314A,\u314B,\u314C,\u314D,\u314E', [',']);
    var tmp_2 = this;
    // Inline function 'kotlin.collections.toTypedArray' call
    // Inline function 'kotlin.collections.map' call
    var this_2 = this.h4_1;
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$(this_2.length);
    var inductionVariable_0 = 0;
    var last_0 = this_2.length;
    while (inductionVariable_0 < last_0) {
      var item_0 = this_2[inductionVariable_0];
      inductionVariable_0 = inductionVariable_0 + 1 | 0;
      // Inline function 'HangulProcessor.finaleCodes.<anonymous>' call
      // Inline function 'kotlin.code' call
      var this_3 = item_0.q_1;
      var tmp$ret$12 = Char__toInt_impl_vasixd(this_3);
      destination_0.x1(tmp$ret$12);
    }
    tmp_2.j4_1 = copyToArray(destination_0);
    var tmp_3 = this;
    // Inline function 'kotlin.arrayOf' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp_3.k4_1 = [new Symbol(_Char___init__impl__6a9atx(12623)), new Symbol(_Char___init__impl__6a9atx(12624)), new Symbol(_Char___init__impl__6a9atx(12625)), new Symbol(_Char___init__impl__6a9atx(12626)), new Symbol(_Char___init__impl__6a9atx(12627)), new Symbol(_Char___init__impl__6a9atx(12628)), new Symbol(_Char___init__impl__6a9atx(12629)), new Symbol(_Char___init__impl__6a9atx(12630)), new Symbol(_Char___init__impl__6a9atx(12631)), new Symbol(_Char___init__impl__6a9atx(12632), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12623)]))), new Symbol(_Char___init__impl__6a9atx(12633), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12624)]))), new Symbol(_Char___init__impl__6a9atx(12634), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12631), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12635)), new Symbol(_Char___init__impl__6a9atx(12636)), new Symbol(_Char___init__impl__6a9atx(12637), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12627)]))), new Symbol(_Char___init__impl__6a9atx(12638), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12628)]))), new Symbol(_Char___init__impl__6a9atx(12639), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12636), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12640)), new Symbol(_Char___init__impl__6a9atx(12641)), new Symbol(_Char___init__impl__6a9atx(12642), codePointArray(charArrayOf([_Char___init__impl__6a9atx(12641), _Char___init__impl__6a9atx(12643)]))), new Symbol(_Char___init__impl__6a9atx(12643))];
    var tmp_4 = this;
    // Inline function 'kotlin.collections.toTypedArray' call
    // Inline function 'kotlin.collections.map' call
    var this_4 = this.k4_1;
    // Inline function 'kotlin.collections.mapTo' call
    var destination_1 = ArrayList_init_$Create$(this_4.length);
    var inductionVariable_1 = 0;
    var last_1 = this_4.length;
    while (inductionVariable_1 < last_1) {
      var item_1 = this_4[inductionVariable_1];
      inductionVariable_1 = inductionVariable_1 + 1 | 0;
      // Inline function 'HangulProcessor.medialCodes.<anonymous>' call
      // Inline function 'kotlin.code' call
      var this_5 = item_1.y4_1;
      var tmp$ret$20 = Char__toInt_impl_vasixd(this_5);
      destination_1.x1(tmp$ret$20);
    }
    tmp_4.l4_1 = copyToArray(destination_1);
    var tmp_5 = this;
    // Inline function 'kotlin.arrayOf' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp_5.m4_1 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 800, 801, 820, 0, 0, 1304, 1305, 1320, 0, 0, 1820];
    var tmp_6 = this;
    // Inline function 'kotlin.arrayOf' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    tmp_6.n4_1 = [0, 0, 0, 119, 0, 422, 427, 0, 0, 801, 816, 817, 819, 825, 826, 827, 0, 0, 1719, 0, 1919];
    this.o4_1 = 44032;
    this.p4_1 = 12623;
    this.q4_1 = 21;
    this.r4_1 = 588;
    this.s4_1 = this.j4_1.length;
    this.t4_1 = this.g4_1.length;
    this.u4_1 = imul(imul(this.t4_1, 21), this.s4_1);
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.t4_1 === 19)) {
      // Inline function 'HangulProcessor.<anonymous>' call
      var message = 'Initial count must be equal to 19';
      throw IllegalArgumentException_init_$Create$(toString_0(message));
    }
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.s4_1 === 28)) {
      // Inline function 'HangulProcessor.<anonymous>' call
      var message_0 = 'Finale count must be equal to 28';
      throw IllegalArgumentException_init_$Create$(toString_0(message_0));
    }
  }
  protoOf(HangulProcessor).v4 = function (input) {
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(input) === 0)
      return '';
    // Inline function 'kotlin.code' call
    var this_0 = charSequenceGet(input, 0);
    var syllableCode = Char__toInt_impl_vasixd(this_0);
    var result = fromCharCode(new Int32Array([syllableCode]));
    var inductionVariable = 1;
    var last = input.length;
    if (inductionVariable < last)
      $l$loop_4: do {
        var charIdx = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        // Inline function 'kotlin.code' call
        var this_1 = charSequenceGet(input, charIdx);
        var currentCode = Char__toInt_impl_vasixd(this_1);
        var initialCode = indexOf(this.g4_1, syllableCode);
        var vowelDiff = currentCode - 12623 | 0;
        if (!(initialCode === -1)) {
          if (0 <= vowelDiff ? vowelDiff < 21 : false) {
            syllableCode = 44032 + imul(imul(initialCode, 21) + vowelDiff | 0, this.s4_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        var relativeSyllableCode = syllableCode - 44032 | 0;
        var finalConsonant = relativeSyllableCode % this.s4_1 | 0;
        if ((0 <= relativeSyllableCode ? relativeSyllableCode <= 11144 : false) && finalConsonant === 0) {
          var currentFinale = indexOf(this.j4_1, currentCode);
          if (!(currentFinale === -1)) {
            syllableCode = syllableCode + currentFinale | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
          var mediaVowelBase = (relativeSyllableCode % 588 | 0) / this.s4_1 | 0;
          var doubledMedialVowel = indexOf(this.m4_1, imul(mediaVowelBase, 100) + (currentCode - 12623 | 0) | 0);
          if (doubledMedialVowel > 0) {
            syllableCode = syllableCode + imul(doubledMedialVowel - mediaVowelBase | 0, this.s4_1) | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        if ((0 <= relativeSyllableCode ? relativeSyllableCode < this.u4_1 : false) && !(finalConsonant === 0)) {
          if (0 <= vowelDiff ? vowelDiff < 21 : false) {
            initialCode = indexOf(this.g4_1, this.j4_1[finalConsonant]);
            if (0 <= initialCode ? initialCode < this.t4_1 : false) {
              result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode - finalConsonant | 0]));
              syllableCode = 44032 + imul(imul(initialCode, 21) + vowelDiff | 0, this.s4_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
            if (finalConsonant < this.n4_1.length && !(this.n4_1[finalConsonant] === 0)) {
              var tmp = sliceExclusive(result, numberRangeToNumber(0, result.length));
              var tmp_0 = syllableCode - finalConsonant | 0;
              // Inline function 'kotlin.math.floor' call
              var x = this.n4_1[finalConsonant] / 100.0;
              var tmp$ret$3 = Math.floor(x);
              result = tmp + fromCharCode(new Int32Array([tmp_0 + numberToInt(tmp$ret$3) | 0]));
              syllableCode = 44032 + imul(imul(indexOf(this.g4_1, this.j4_1[this.n4_1[finalConsonant] % 100 | 0]), 21) + vowelDiff | 0, this.s4_1) | 0;
              result = result + fromCharCode(new Int32Array([syllableCode]));
              continue $l$loop_4;
            }
          }
          var doubledFinaleConsonant = indexOf(this.n4_1, imul(finalConsonant, 100) + indexOf(this.j4_1, currentCode) | 0);
          if (doubledFinaleConsonant > 0) {
            syllableCode = (syllableCode + doubledFinaleConsonant | 0) - finalConsonant | 0;
            result = sliceExclusive(result, numberRangeToNumber(0, result.length)) + fromCharCode(new Int32Array([syllableCode]));
            continue $l$loop_4;
          }
        }
        syllableCode = currentCode;
        result = result + fromCharCode(new Int32Array([currentCode]));
      }
       while (inductionVariable < last);
    return result;
  };
  protoOf(HangulProcessor).x4 = function (input) {
    var result = '';
    var inductionVariable = 0;
    var last = input.length;
    $l$loop: while (inductionVariable < last) {
      var char = charSequenceGet(input, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'kotlin.code' call
      var syllableIndex = Char__toInt_impl_vasixd(char) - 44032 | 0;
      if (syllableIndex < 0 || syllableIndex >= this.u4_1) {
        result = result + toString(char);
        continue $l$loop;
      }
      // Inline function 'kotlin.math.floor' call
      var x = syllableIndex / 588;
      var tmp$ret$1 = Math.floor(x);
      var initialCode = this.g4_1[numberToInt(tmp$ret$1)];
      var syllable = 12623 + ((syllableIndex % 588 | 0) / this.s4_1 | 0) | 0;
      var finaleCode = this.j4_1[syllableIndex % this.s4_1 | 0];
      var tmp$ret$4;
      $l$block: {
        // Inline function 'kotlin.collections.firstOrNull' call
        var indexedObject = this.k4_1;
        var inductionVariable_0 = 0;
        var last_0 = indexedObject.length;
        while (inductionVariable_0 < last_0) {
          var element = indexedObject[inductionVariable_0];
          inductionVariable_0 = inductionVariable_0 + 1 | 0;
          // Inline function 'HangulProcessor.decomposeHangul.<anonymous>' call
          // Inline function 'kotlin.code' call
          var this_0 = element.y4_1;
          if (Char__toInt_impl_vasixd(this_0) === syllable) {
            tmp$ret$4 = element;
            break $l$block;
          }
        }
        tmp$ret$4 = null;
      }
      var tmp1_safe_receiver = tmp$ret$4;
      var tmp0_elvis_lhs = tmp1_safe_receiver == null ? null : tmp1_safe_receiver.z4_1;
      var tmp;
      if (tmp0_elvis_lhs == null) {
        // Inline function 'kotlin.intArrayOf' call
        tmp = new Int32Array([syllable]);
      } else {
        tmp = tmp0_elvis_lhs;
      }
      var syllableStructure = tmp;
      result = result + fromCharCode(primitiveArrayConcat([new Int32Array([initialCode]), syllableStructure]));
      if (!(finaleCode === 0)) {
        result = result + this.i4_1.i(syllableIndex % this.s4_1 | 0);
      }
    }
    return result;
  };
  var HangulProcessor_instance;
  function HangulProcessor_getInstance() {
    if (HangulProcessor_instance == null)
      new HangulProcessor();
    return HangulProcessor_instance;
  }
  function sliceExclusive(_this__u8e3s4, range) {
    return slice(_this__u8e3s4, until(range.v2_1, range.w2_1 - 2 | 0));
  }
  function fromCharCode(codePoints) {
    var builder = StringBuilder_init_$Create$(codePoints.length);
    var inductionVariable = 0;
    var last = codePoints.length;
    while (inductionVariable < last) {
      var codePoint = codePoints[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      appendCodePoint(builder, codePoint);
    }
    return builder.toString();
  }
  function codePointArray(chars) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(chars.length);
    var inductionVariable = 0;
    var last = chars.length;
    while (inductionVariable < last) {
      var item = chars[inductionVariable];
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'codePointArray.<anonymous>' call
      // Inline function 'kotlin.code' call
      var tmp$ret$1 = Char__toInt_impl_vasixd(item);
      destination.x1(tmp$ret$1);
    }
    return toIntArray(destination);
  }
  //region block: post-declaration
  defineProp(protoOf(RemovePolicy), 'name', protoOf(RemovePolicy).f1);
  defineProp(protoOf(RemovePolicy), 'ordinal', protoOf(RemovePolicy).g1);
  //endregion
  //region block: exports
  function $jsExportAll$(_) {
    _.RemovePolicy = RemovePolicy;
    _.RemovePolicy.values = values;
    _.RemovePolicy.valueOf = valueOf;
    defineProp(_.RemovePolicy, 'DEFAULT', RemovePolicy_DEFAULT_getInstance);
    defineProp(_.RemovePolicy, 'REFORMAT_ON_DELETE', RemovePolicy_REFORMAT_ON_DELETE_getInstance);
    _.HangulContext = HangulContext;
    _.HangulContext.deleteAtCaret$default = deleteAtCaret$default;
  }
  $jsExportAll$(_);
  //endregion
  return _;
}));

//# sourceMappingURL=khangul.js.map
